package jp.gr.java_conf.coskx.teststrageapi30;

/*
* save1 は，アプリ固有の内部メモリ領域に書き込む。
* load1 は，アプリ固有の内部メモリ領域から読み出す。
* アプリ固有の内部メモリ領域へのファイルアクセスには，権限は不要
* この固有の内部メモリ領域に関して権限不要なのは，android7.0以降で動作する
* Device File Explorer（Android Studio - View - Tool Windows - Device File Explorer）で見ると
* /data/data/jp.gr.java_conf.coskx.teststrageapi30/files
* が固有の内部メモリ領域と見えるが
* String.valueOf(this.getFilesDir());で見ると
* /data/user/0/jp.gr.java_conf.coskx.teststrageapi30/files
* が固有の内部メモリ領域と見える
* しかもデバイス上のファイルマネージャアプリからは，固有の内部メモリ領域は見えない
* PCとUSB接続してもPCのディレクトリファイル一覧からも見えない
*
 * save2 は，アプリ固有の外部メモリ領域に書き込む。
 * load2 は，アプリ固有の外部メモリ領域から読み出す。
 * アプリ固有の外部メモリ領域へのファイルアクセスには，権限は不要
 * この固有の外部メモリ領域に関して権限不要なのは，android7.0以降で動作する
 * Device File Explorer（Android Studio - View - Tool Windows - Device File Explorer）で見ると
 * 見つからない
 * String.valueOf(this.getExternalFilesDir(Environment.DIRECTORY_DOCUMENTS));で見ると
 * /storage/emulated/0/Android/data/jp.gr.java_conf.coskx.teststrageapi30/files/Documents
 * が固有の外部メモリ領域と見える
 * しかもデバイス上のファイルマネージャアプリからは，固有の外部メモリ領域は見えない
 * PCとUSB接続してもPCのディレクトリファイル一覧からも見えない
 *
 * 外部内部と言っても内蔵ストレージ，SDカードを意味するわけではない
 * SDカードのない機種でも外部メモリ保存はできる
 * この２つの方法は他のアプリからは絶対に見えない　違う
 * https://developer.android.com/training/data-storage　英語版が正しい　いややはり間違っている
 *
 * 20210314　pixel4a(android11最新)等で確認
 * Pixel 4a　android 11 API30 P
 * 「外部メモリ領域」でのファイルが
 * WinPCでUSB接続し，ファイル一覧で
 * Pixel 4a\内部共有ストレージ\Android\data\jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える(最新情報に更新操作が必要)
 * device内ではFileManager(File Manager Plus alphainventor.com)で
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える
 * device内ではFiles by Google(Google LLC)で
 * 内部ストレージ/Android/data
 * までしか見えない
 * device内ではFileManager(Smart Tool Pro transsion.com)で
 * 内部ストレージ/Android/data
 * までしかたどり着けない
 *
 * HUAWEI P10 lite android 7 API 26 N
 * 外部メモリ領域でのファイルが
 * WinPCでUSB接続し，ファイル一覧で
 * HUAWEI P10 lite Tommy\内部ストレージ\Android\data\jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える(最新情報に更新操作が必要)
 * finalizeが必要
 * device内ではFileManager(File Manager Plus alphainventor.com)で
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える
 * device内ではFiles by Google(Google LLC)で
 * 内部ストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える
 *
 * Nexus5X android 8 API 27 O
 * 外部メモリ領域でのファイルが
 * WinPCでUSB接続し，ファイル一覧で
 * Nexus 5X\内部共有ストレージ\Android\data\jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える(最新情報に更新操作が必要)
 * finalizeが必要
 * device内ではFileManager(File Manager Plus alphainventor.com)で
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える
 * device内ではFiles by Google(Google LLC)で
 * 内部ストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える
 *
 * Nexus7 android 6.01 API 25 M
 * 外部メモリ領域でのファイルが
 * WinPCでUSB接続し，ファイル一覧で
 * Nexus 7\内部ストレージ\Android\data\jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える(最新情報に更新操作が必要)
 * finalizeが必要
 * device内ではFileManager(File Manager Plus alphainventor.com)で
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える
 * device内ではFiles by Google(Google LLC)で
 * 内部ストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見える
 *
 * -- emulator --
 * Pixel4 API27
 * ?　PCにつないではチェックできない
 * ?　device内ではFiles by Google(Google LLC)で
 * 内部ストレージにたどり着けない
 * 〇　device内ではx-plorer file managerで
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見え，ファイルの内容まで見える（途中で権限確認あり）
 * ?　device内ではFileManager(File Manager Plus alphainventor.com)で
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files
 * までしかたどり付けないのでどうなっているのか不明
 * ?　device内ではFileManager(Smart Tool Pro transsion.com)で
 * 内部ストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見えるけれど，開くためのアプリがないため開けない
 *
 * Pixel4 API28
 * ?　PCにつないではチェックできない
 * 〇　device内ではFiles by Google(Google LLC)で
 * 内部ストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見え，ファイルの内容まで見える
 * 〇　device内ではx-plorer file managerで
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見え，ファイルの内容まで見える（途中で権限確認あり）
 * ?　device内ではFileManager(File Manager Plus alphainventor.com)で
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files
 * までしかたどり付けないのでどうなっているのか不明
 * ?　device内ではFileManager(Smart Tool Pro transsion.com)で
 * 内部ストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見えるけれど，開くためのアプリがないため開けない
 *
 * Pixel3a API29
 * ?　PCにつないではチェックできない
 * 〇　device内ではFiles by Google(Google LLC)で
 * 内部ストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見え，ファイルの内容まで見える
 * 〇　device内ではx-plorer file managerで
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見え，ファイルの内容まで見える（途中で権限確認あり）
 * ?　device内ではFileManager(File Manager Plus alphainventor.com)で
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files
 * までしかたどり着けない
 * ?　device内ではFileManager(Smart Tool Pro transsion.com)で
 * 内部ストレージ/Android/data
 * までしかたどり着けない
 *
 * Pixel3a API30
 * ?　PCにつないではチェックできない
 * 〇　device内ではFiles by Google(Google LLC)で
 * 内部ストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見え，ファイルの内容まで見える
 * 〇　device内ではx-plorer file managerで
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files\Documents
 * の中にファイルが見え，ファイルの内容まで見える（途中で権限確認あり）
 * ?　device内ではFileManager(File Manager Plus alphainventor.com)で
 * メインストレージ/Android/data/jp.gr.java_conf.coskx.teststrageapi30\files
 * までしかたどり着けない
 * ?　device内ではFileManager(Smart Tool Pro transsion.com)で
 * 内部ストレージ/Android/data
 * までしかたどり着けない
 */

import android.os.Bundle;
import android.os.Environment;
import android.text.method.ScrollingMovementMethod;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import androidx.appcompat.app.AppCompatActivity;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class MainActivity extends AppCompatActivity implements View.OnClickListener{
    private final static String TAG = "MainActivity";

    TextView result1, result2;
    Button save1,save2;
    Button load1,load2;
    Button dir1,dir2;
    Button delete1,delete2;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        result1 = findViewById(R.id.result1);
        result2 = findViewById(R.id.result2);
        result1.setMovementMethod(new ScrollingMovementMethod());
        result2.setMovementMethod(new ScrollingMovementMethod());
        save1 = findViewById(R.id.save1);
        save1.setOnClickListener(this);
        save2 = findViewById(R.id.save2);
        save2.setOnClickListener(this);
        load1 = findViewById(R.id.load1);
        load1.setOnClickListener(this);
        load2 = findViewById(R.id.load2);
        load2.setOnClickListener(this);
        dir1 = findViewById(R.id.dir1);
        dir1.setOnClickListener(this);
        dir2 = findViewById(R.id.dir2);
        dir2.setOnClickListener(this);
        delete1 = findViewById(R.id.delete1);
        delete1.setOnClickListener(this);
        delete2 = findViewById(R.id.delete2);
        delete2.setOnClickListener(this);

        String internalstorage = String.valueOf(this.getFilesDir());
        Log.i(TAG,"onCreate()  internalstorage = " + internalstorage);
        //I/MainActivity: onCreate()  internalstorage = /data/user/0/jp.gr.java_conf.coskx.teststrageapi30/files　こうなるのですが？
        String externalstorage = String.valueOf(this.getExternalFilesDir(Environment.DIRECTORY_DOCUMENTS));
        Log.i(TAG,"onCreate()  externalstorage = " + externalstorage);
        //I/MainActivity: onCreate()  externalstorage = /storage/emulated/0/Android/data/jp.gr.java_conf.coskx.teststrageapi30/files/Documents
        //こちらの方が後から見える可能性がある

    }

    public void onClick(View view){
        String internalfname = "intsample.txt";
        String externalfname = "extsample.txt";
        String internaltext = "Hello,\nTHis is a internalstorage sample text.\n";
        String externaltext = "Hello,\nTHis is a externalstorage sample text.\n";
        File file1;
        File dir;
        File[] files;
        String message;
        if (view==save1) {  //アプリ固有の内部メモリ領域に書き込む。
            //String fullpath =  internalstorage + "/" + internalfname;
            //fullpath　/data/user/0/jp.gr.java_conf.coskx.teststrageapi30/files/internaltxt.txt　ではなく
            ///data/data/jp.gr.java_conf.coskx.teststrageapi30/files/internaltxt.txt に書き込まれる
            file1 = new File(this.getFilesDir(), internalfname);
            //FileWriterの第2引数は上書き又は追記を指示する　true：追記
            try (FileWriter writer = new FileWriter(file1,true)) {
                writer.write(internaltext);
                writer.flush();
                writer.close();
                message = "File saved.";
            } catch (IOException e) {
                message = e.getMessage();
                e.printStackTrace();
            }
            result1.setText(message);
            Log.i(TAG, message);
        }else if (view==load1) {  //アプリ固有の内部メモリ領域から読み出す。
            StringBuilder text = new StringBuilder();
            file1 = new File(this.getFilesDir(), internalfname);
            try (BufferedReader reader = new BufferedReader(new FileReader(file1))) {
                String lineBuffer;
                lineBuffer = reader.readLine();
                while (lineBuffer != null) {
                    text.append(lineBuffer).append("\n");
                    lineBuffer = reader.readLine();
                }
                message = "text read = [\n" + text + "]";
            } catch (IOException e) {
                message = e.getMessage();
                e.printStackTrace();
            }
            result1.setText(message);
            Log.i(TAG, message);
        }else if (view==dir1) {  //アプリ固有の内部メモリ領域ファイル一覧。
            StringBuilder text = new StringBuilder("\n");
            dir = this.getFilesDir();
            files = dir.listFiles();
            if (files != null) {
                for (File file : files) {
                    text.append(file.getName()).append("\n");
                }
            }
            message = "listed filenames = [" + text.toString() + "]";
            result1.setText(message);
            Log.i(TAG, message);
        }else if (view==delete1) {  //アプリ固有の内部メモリ領域ファイルを全て消去。
            StringBuilder text = new StringBuilder("\n");
            dir = this.getFilesDir();
            files = dir.listFiles();
            if (files != null) {
                for (File file : files) {
                    text.append(file.getName()).append("\n");
                    file.delete();
                }
            }
            message = "deleted files = [" + text.toString() + "]";
            result1.setText(message);
            Log.i(TAG, message);
        } else if (view==save2) {   //アプリ固有の外部メモリ領域に書き込む。
            //これは外部メモリのアプリ固有の領域への書き込み
            dir = this.getExternalFilesDir(Environment.DIRECTORY_DOCUMENTS);
            file1 = new File(dir, externalfname);
            Log.i(TAG,"file name = " + String.valueOf(file1));
            //storage/emulated/0/Android/data/jp.gr.java_conf.coskx.teststrageapi30/files/Documents/externaltxt.txt
            //Android device 内のファイルマネージャアプリでは，storage/emulated/0/内だけが見える
            try (FileWriter writer = new FileWriter(file1,true)) {
                writer.write(externaltext);
                writer.flush();
                writer.close();
                message = "File saved.";
            } catch (IOException e) {
                message = e.getMessage();
                e.printStackTrace();
            }
            result2.setText(message);
            Log.i(TAG, message);
        } else if (view==load2) {  //アプリ固有の外部メモリ領域から読み出す。
            StringBuilder text = new StringBuilder();
            dir = this.getExternalFilesDir(Environment.DIRECTORY_DOCUMENTS);
            file1 = new File(dir, externalfname);
            try (BufferedReader reader = new BufferedReader(new FileReader(file1))) {
                String lineBuffer;
                lineBuffer = reader.readLine();
                while (lineBuffer != null) {
                    text.append(lineBuffer).append("\n");
                    lineBuffer = reader.readLine();
                }
                message = "text read = [\n" + text + "]";
            } catch (IOException e) {
                message = e.getMessage();
                e.printStackTrace();
            }
            result2.setText(message);
            Log.i(TAG, message);
        }else if (view==dir2) {  //アプリ固有の外部メモリ領域ファイル一覧。
            StringBuilder text = new StringBuilder("\n");
            dir = this.getExternalFilesDir(Environment.DIRECTORY_DOCUMENTS);
            files = dir.listFiles();
            if (files != null) {
                for (File file : files) {
                    text.append(file.getName()).append("\n");
                }
            }
            message = "listed filenames = [" + text.toString() + "]";
            result2.setText(message);
            Log.i(TAG, message);
        }else if (view==delete2) {  //アプリ固有の外部メモリ領域ファイルを全て消去。
            StringBuilder text = new StringBuilder("\n");
            dir = this.getExternalFilesDir(Environment.DIRECTORY_DOCUMENTS);
            files = dir.listFiles();
            if (files != null) {
                for (File file : files) {
                    text.append(file.getName()).append("\n");
                    file.delete();
                }
            }
            message = "deleted files = [" + text.toString() + "]";
            result2.setText(message);
            Log.i(TAG, message);
        }
    }
}

